Index: channels/chan_sip.c
===================================================================
--- channels/chan_sip.c	(revision 34061)
+++ channels/chan_sip.c	(working copy)
@@ -10941,7 +10932,7 @@
 		codecnum = colname + 6;	/* move past the '[' */
 		codecnum = strsep(&codecnum, "]"); /* trim trailing ']' if any */
 		index = atoi(codecnum);
-		if((codec = ast_codec_pref_index(&peer->prefs, index))) {
+		if((codec = ast_codec_pref_index_audio(&peer->prefs, index))) {
 			ast_copy_string(buf, ast_getformatname(codec), len);
 		}
 	}
@@ -12681,7 +12672,6 @@
 					return -1;
 				}
 			} else {
-				p->jointcapability = p->capability;
 				ast_log(LOG_DEBUG, "Hm....  No sdp for the moment\n");
 			}
 			if (recordhistory) /* This is a response, note what it was for */
@@ -12721,7 +12711,6 @@
 				return -1;
 			}
 		} else {	/* No SDP in invite, call control session */
-			p->jointcapability = p->capability;
 			if (option_debug > 1)
 				ast_log(LOG_DEBUG, "No SDP in Invite, third party call control\n");
 		}
@@ -12955,7 +12944,7 @@
 		if (p && !ast_test_flag(&p->flags[0], SIP_NEEDDESTROY)) {
 			const char *msg;
 
-			if (!p->jointcapability)
+			if (!ast_codec_pref_bits(&p->formats))
 				msg = "488 Not Acceptable Here (codec error)";
 			else {
 				ast_log(LOG_NOTICE, "Unable to create/find SIP channel for this INVITE\n");
@@ -14528,23 +14517,16 @@
 
 /*! \brief PBX interface function -build SIP pvt structure */
 /* SIP calls initiated by the PBX arrive here */
-static struct ast_channel *sip_request_call(const char *type, int format, void *data, int *cause)
+static struct ast_channel *sip_request_call(const char *type, const struct ast_codec_pref *formats, void *data, int *cause)
 {
-	int oldformat;
 	struct sip_pvt *p;
 	struct ast_channel *tmpc = NULL;
 	char *ext, *host;
 	char tmp[256];
 	char *dest = data;
 
-	oldformat = format;
-	if (!(format &= ((AST_FORMAT_MAX_AUDIO << 1) - 1))) {
-		ast_log(LOG_NOTICE, "Asked to get a channel of unsupported format %s while capability is %s\n", ast_getformatname(oldformat), ast_getformatname(global_capability));
-		*cause = AST_CAUSE_BEARERCAPABILITY_NOTAVAIL;	/* Can't find codec to connect to host */
-		return NULL;
-	}
 	if (option_debug)
-		ast_log(LOG_DEBUG, "Asked to create a SIP channel with formats: %s\n", ast_getformatname_multiple(tmp, sizeof(tmp), oldformat));
+		ast_log(LOG_DEBUG, "Asked to create a SIP channel with formats: %s\n", ast_codec_pref_dump(tmp, sizeof(tmp), formats));
 
 	if (!(p = sip_alloc(NULL, NULL, 0, SIP_INVITE))) {
 		ast_log(LOG_ERROR, "Unable to build sip pvt data for '%s' (Out of memory or socket error)\n", (char *)data);
@@ -14570,6 +14552,7 @@
 			*ext++ = '\0';
 		host = tmp;
 	}
+	ast_codec_pref_combine(&p->formats, formats, global_capability);
 
 	if (create_addr(p, host)) {
 		*cause = AST_CAUSE_UNREGISTERED;
@@ -14597,7 +14580,6 @@
 #if 0
 	printf("Setting up to call extension '%s' at '%s'\n", ext ? ext : "<none>", host);
 #endif
-	p->prefcodec = oldformat;				/* Format for this call */
 	ast_mutex_lock(&p->lock);
 	tmpc = sip_new(p, AST_STATE_DOWN, host);	/* Place the call */
 	ast_mutex_unlock(&p->lock);
@@ -15972,7 +15954,7 @@
 }
 
 /*! \brief Set the RTP peer for this call */
-static int sip_set_rtp_peer(struct ast_channel *chan, struct ast_rtp *rtp, struct ast_rtp *vrtp, int codecs, int nat_active)
+static int sip_set_rtp_peer(struct ast_channel *chan, struct ast_rtp *rtp, struct ast_rtp *vrtp, const struct ast_codec_pref *codecs, int nat_active)
 {
 	struct sip_pvt *p;
 	int changed = 0;
@@ -16003,8 +15985,15 @@
 		changed |= ast_rtp_get_peer(vrtp, &p->vredirip);
 	else
 		memset(&p->vredirip, 0, sizeof(p->vredirip));
-	if (codecs && (p->redircodecs != codecs)) {
-		p->redircodecs = codecs;
+	if (codecs != NULL) {
+		if (ast_codec_pref_bits(&p->redircodecs) != ast_codec_pref_bits(codecs))
+	       	{
+			memcpy(&p->redircodecs, codecs, sizeof(p->redircodecs));
+			changed = 1;
+		}
+	}
+	else if (ast_codec_pref_bits(&p->redircodecs)) {
+		ast_codec_pref_init(&p->redircodecs);
 		changed = 1;
 	}
 	if (changed && !ast_test_flag(&p->flags[0], SIP_GOTREFER)) {
@@ -16190,13 +16179,6 @@
 
 	/* hangup here */
 	return -1;
-}
-
-/*! \brief Return SIP UA's codec (part of the RTP interface) */
-static int sip_get_codec(struct ast_channel *chan)
-{
-	struct sip_pvt *p = chan->tech_pvt;
-	return p->peercapability;	
 }
 
 /*! \brief Send a poke to all known peers */
Index: channels/chan_skinny.c
===================================================================
--- channels/chan_skinny.c	(revision 34061)
+++ channels/chan_skinny.c	(working copy)
@@ -905,7 +905,7 @@
 	struct skinnysession *next;
 } *sessions = NULL;
 
-static struct ast_channel *skinny_request(const char *type, int format, void *data, int *cause);
+static struct ast_channel *skinny_request(const char *type, const struct ast_codec_pref *format, void *data, int *cause);
 static int skinny_call(struct ast_channel *ast, char *dest, int timeout);
 static int skinny_hangup(struct ast_channel *ast);
 static int skinny_answer(struct ast_channel *ast);
@@ -1349,7 +1349,7 @@
 	return NULL;
 }
 
-static int skinny_set_rtp_peer(struct ast_channel *chan, struct ast_rtp *rtp, struct ast_rtp *vrtp, int codecs, int nat_active)
+static int skinny_set_rtp_peer(struct ast_channel *chan, struct ast_rtp *rtp, struct ast_rtp *vrtp, const struct ast_codec_pref *codecs, int nat_active)
 {
 	struct skinny_subchannel *sub;
 	sub = chan->tech_pvt;
@@ -2063,9 +2063,9 @@
 	if (sub->owner) {
 		/* We already hold the channel lock */
 		if (f->frametype == AST_FRAME_VOICE) {
-			if (f->subclass != sub->owner->nativeformats) {
+			if (!(f->subclass & ast_codec_pref_bits(&sub->owner->nativeformats))) {
 				ast_log(LOG_DEBUG, "Oooh, format changed to %d\n", f->subclass);
-				sub->owner->nativeformats = f->subclass;
+				ast_codec_pref_append(&sub->owner->nativeformats, f->subclass);
 				ast_set_read_format(sub->owner, sub->owner->readformat);
 				ast_set_write_format(sub->owner, sub->owner->writeformat);
 			}
@@ -2096,9 +2096,9 @@
 			return 0;
 		}
 	} else {
-		if (!(frame->subclass & ast->nativeformats)) {
+		if (!(frame->subclass & ast_codec_pref_bits(&ast->nativeformats))) {
 			ast_log(LOG_WARNING, "Asked to transmit frame type %d, while native formats is %d (read/write = %d/%d)\n",
-				frame->subclass, ast->nativeformats, ast->readformat, ast->writeformat);
+				frame->subclass, ast_codec_pref_bits(&ast->nativeformats), ast->readformat, ast->writeformat);
 			return -1;
 		}
 	}
@@ -2254,12 +2254,12 @@
 	tmp = ast_channel_alloc(1);
 	if (tmp) {
 		tmp->tech = &skinny_tech;
-		tmp->nativeformats = l->capability;
-		if (!tmp->nativeformats)
-			tmp->nativeformats = capability;
-		fmt = ast_best_codec(tmp->nativeformats);
+		ast_codec_pref_append_missing2(&tmp->nativeformats, l->capability);
+		if (!ast_codec_pref_bits(&tmp->nativeformats))
+			ast_codec_pref_append_missing2(&tmp->nativeformats, capability);
+		fmt = ast_best_codec(ast_codec_pref_bits(&tmp->nativeformats));
 		if (skinnydebug) {
-			ast_verbose("skinny_new: tmp->nativeformats=%d fmt=%d\n", tmp->nativeformats, fmt);
+			ast_verbose("skinny_new: tmp->nativeformats=%d fmt=%d\n", ast_codec_pref_bits(&tmp->nativeformats), fmt);
 		}
 		ast_string_field_build(tmp, name, "Skinny/%s@%s-%d", l->name, l->parent->name, sub->callid);
 		if (sub->rtp) {
@@ -3049,20 +3049,13 @@
 	return 0;
 }
 
-static struct ast_channel *skinny_request(const char *type, int format, void *data, int *cause)
+static struct ast_channel *skinny_request(const char *type, const struct ast_codec_pref *formats, void *data, int *cause)
 {
-	int oldformat;
 	struct skinny_subchannel *sub;
 	struct ast_channel *tmpc = NULL;
 	char tmp[256];
 	char *dest = data;
 
-	oldformat = format;
-	format &= capability;
-	if (!format) {
-		ast_log(LOG_NOTICE, "Asked to get a channel of unsupported format '%d'\n", format);
-		return NULL;
-	}
 	ast_copy_string(tmp, dest, sizeof(tmp));
 	if (ast_strlen_zero(tmp)) {
 		ast_log(LOG_NOTICE, "Skinny channels require a device\n");
Index: channels/chan_zap.c
===================================================================
--- channels/chan_zap.c	(revision 34061)
+++ channels/chan_zap.c	(working copy)
@@ -694,7 +694,7 @@
 	int dsp_features;
 } *iflist = NULL, *ifend = NULL;
 
-static struct ast_channel *zt_request(const char *type, int format, void *data, int *cause);
+static struct ast_channel *zt_request(const char *type, const struct ast_codec_pref *format, void *data, int *cause);
 static int zt_digit(struct ast_channel *ast, char digit);
 static int zt_sendtext(struct ast_channel *c, const char *text);
 static int zt_call(struct ast_channel *ast, char *rdest, int timeout);
@@ -5076,7 +5076,7 @@
 			y++;
 		} while (x < 3);
 		tmp->fds[0] = i->subs[index].zfd;
-		tmp->nativeformats = AST_FORMAT_SLINEAR | deflaw;
+		ast_codec_pref_append_missing2(&tmp->nativeformats, AST_FORMAT_SLINEAR | deflaw);
 		/* Start out assuming ulaw since it's smaller :) */
 		tmp->rawreadformat = deflaw;
 		tmp->readformat = deflaw;
@@ -7558,7 +7558,7 @@
 }
 #endif
 
-static struct ast_channel *zt_request(const char *type, int format, void *data, int *cause)
+static struct ast_channel *zt_request(const char *type, const struct ast_codec_pref *format, void *data, int *cause)
 {
 	int groupmatch = 0;
 	int channelmatch = -1;
@@ -8227,9 +8227,12 @@
 #endif
 			if (nextidle > -1) {
 				if (ast_tvdiff_ms(ast_tvnow(), lastidle) > 1000) {
+					struct ast_codec_pref ulaw;
+					ast_codec_pref_init(&ulaw);
+					ast_codec_pref_append(&ulaw, AST_FORMAT_ULAW);
 					/* Don't create a new idle call more than once per second */
 					snprintf(idlen, sizeof(idlen), "%d/%s", pri->pvts[nextidle]->channel, pri->idledial);
-					idle = zt_request("Zap", AST_FORMAT_ULAW, idlen, &cause);
+					idle = zt_request("Zap", &ulaw, idlen, &cause);
 					if (idle) {
 						pri->pvts[nextidle]->isidlecall = 1;
 						if (ast_pthread_create(&p, NULL, do_idle_thread, idle)) {
Index: channels/iax2-parser.c
===================================================================
--- channels/iax2-parser.c	(revision 34061)
+++ channels/iax2-parser.c	(working copy)
@@ -95,7 +95,7 @@
 	strncpy(output, value, maxlen);
 	output[maxlen] = '\0';
 	
-	ast_codec_pref_convert(&pref, output, total_len, 0);
+	ast_codec_pref_convert_from_buf(&pref, output, total_len);
 	memset(output,0,total_len);
 	ast_codec_pref_string(&pref, output, total_len);
 }
Index: cli.c
===================================================================
--- cli.c	(revision 34061)
+++ cli.c	(working copy)
@@ -700,8 +700,6 @@
 		"  NativeFormats: %s\n"
 		"    WriteFormat: %s\n"
 		"     ReadFormat: %s\n"
-		" WriteTranscode: %s\n"
-		"  ReadTranscode: %s\n"
 		"1st File Descriptor: %d\n"
 		"      Frames in: %d%s\n"
 		"     Frames out: %d%s\n"
@@ -722,11 +720,9 @@
 		S_OR(c->cid.cid_num, "(N/A)"),
 		S_OR(c->cid.cid_name, "(N/A)"),
 		S_OR(c->cid.cid_dnid, "(N/A)"), ast_state2str(c->_state), c->_state, c->rings, 
-		ast_getformatname_multiple(nf, sizeof(nf), c->nativeformats), 
+		ast_codec_pref_dump(nf, sizeof(nf), &c->nativeformats), 
 		ast_getformatname_multiple(wf, sizeof(wf), c->writeformat), 
 		ast_getformatname_multiple(rf, sizeof(rf), c->readformat),
-		c->writetrans ? "Yes" : "No",
-		c->readtrans ? "Yes" : "No",
 		c->fds[0],
 		c->fin & ~DEBUGCHAN_FLAG, (c->fin & DEBUGCHAN_FLAG) ? " (DEBUGGED)" : "",
 		c->fout & ~DEBUGCHAN_FLAG, (c->fout & DEBUGCHAN_FLAG) ? " (DEBUGGED)" : "",
Index: file.c
===================================================================
--- file.c	(revision 34061)
+++ file.c	(working copy)
@@ -586,7 +586,7 @@
 		int fd;
 		const char *fmt;
 
-		if (!(chan->nativeformats & format))
+		if (!(ast_codec_pref_bits(&chan->nativeformats) & format))
 			continue;
 		fmt = ast_getformatname(format);
 		if ( fileexists_core(filename, fmt, preflang, buf, buflen) < 1)	/* no valid format */
@@ -807,7 +807,7 @@
 #endif
 		return 0;
 	}
-	ast_log(LOG_WARNING, "Unable to open %s (format %s): %s\n", filename, ast_getformatname_multiple(fmt, sizeof(fmt), chan->nativeformats), strerror(errno));
+	ast_log(LOG_WARNING, "Unable to open %s (format %s): %s\n", filename, ast_codec_pref_dump(fmt, sizeof(fmt), &chan->nativeformats), strerror(errno));
 	return -1;
 }
 
Index: frame.c
===================================================================
--- frame.c	(revision 34061)
+++ frame.c	(working copy)
@@ -895,33 +895,57 @@
 	return 0;	
 }
 
-void ast_codec_pref_convert(struct ast_codec_pref *pref, char *buf, size_t size, int right) 
+void ast_codec_pref_convert_to_buf(const struct ast_codec_pref *pref, char *buf, size_t size)
 {
-	int x, differential = (int) 'A', mem;
-	char *from, *to;
-
-	if(right) {
-		from = pref->order;
-		to = buf;
-		mem = size;
-	} else {
-		to = pref->order;
-		from = buf;
-		mem = 32;
+	int limit = size < 32 ? size : 32;
+	int i;
+	int x = 0;
+
+	memset(buf, 0, size);
+	for (i = 0; i < limit; ++i)
+	{
+		if (!pref->audio_order[i])
+			break;
+		buf[i] = pref->audio_order[i] + (int) 'A';
+	}
+	x = i;
+	for (i = 0; (i + x) < limit; ++i)
+	{
+		if (!pref->video_order[i])
+			break;
+		buf[i + x] = pref->video_order[i] + (int) 'A';
 	}
+}
 
-	memset(to, 0, mem);
-	for (x = 0; x < 32 ; x++) {
-		if(!from[x])
+void ast_codec_pref_convert_from_buf(struct ast_codec_pref *pref, char *buf, size_t size)
+{
+	int i;
+	int limit = size < 32 ? size : 32;
+	int slot;
+	static int max_slot = sizeof(AST_FORMAT_LIST) / sizeof(struct ast_format_list);
+
+	ast_codec_pref_init(pref);
+	for (i = 0; i < limit; ++i)
+	{
+		if (!buf[i])
 			break;
-		to[x] = right ? (from[x] + differential) : (from[x] - differential);
+		slot = buf[i] - 1 - (int) 'A';
+		if (slot >= 0 && slot < max_slot) {
+			ast_codec_pref_append(pref, AST_FORMAT_LIST[slot].bits);
+		}
 	}
 }
 
-int ast_codec_pref_string(struct ast_codec_pref *pref, char *buf, size_t size) 
+char *ast_codec_pref_dump(char *buf, size_t size, const struct ast_codec_pref *pref)
+{
+	ast_codec_pref_string(pref, buf, size);
+	return buf;
+}
+
+int ast_codec_pref_string(const struct ast_codec_pref *pref, char *buf, size_t size) 
 {
 	int x, codec; 
-	size_t total_len, slen;
+	size_t total_len, slen = 0;
 	char *formatname;
 	
 	memset(buf,0,size);
@@ -931,7 +955,7 @@
 	for(x = 0; x < 32 ; x++) {
 		if(total_len <= 0)
 			break;
-		if(!(codec = ast_codec_pref_index(pref,x)))
+		if(!(codec = ast_codec_pref_index_audio(pref,x)))
 			break;
 		if((formatname = ast_getformatname(codec))) {
 			slen = strlen(formatname);
@@ -940,7 +964,28 @@
 			strncat(buf,formatname,total_len);
 			total_len -= slen;
 		}
-		if(total_len && x < 31 && ast_codec_pref_index(pref , x + 1)) {
+		if(total_len && x < 31 && ast_codec_pref_index_audio(pref , x + 1)) {
+			strncat(buf,"|",total_len);
+			total_len--;
+		}
+	}
+	if ((slen <= total_len) && pref->video_bits) {
+		strncat(buf,"|",total_len);
+		total_len--;
+	}
+	for(x = 0; x < 32 ; x++) {
+		if(total_len <= 0)
+			break;
+		if(!(codec = ast_codec_pref_index_video(pref,x)))
+			break;
+		if((formatname = ast_getformatname(codec))) {
+			slen = strlen(formatname);
+			if(slen > total_len)
+				break;
+			strncat(buf,formatname,total_len);
+			total_len -= slen;
+		}
+		if(total_len && x < 31 && ast_codec_pref_index_video(pref , x + 1)) {
 			strncat(buf,"|",total_len);
 			total_len--;
 		}
@@ -953,18 +998,34 @@
 	return size - total_len;
 }
 
-int ast_codec_pref_index(struct ast_codec_pref *pref, int index) 
+int ast_codec_pref_index_audio(const struct ast_codec_pref *pref, int index) 
 {
 	int slot = 0;
 
 	
-	if((index >= 0) && (index < sizeof(pref->order))) {
-		slot = pref->order[index];
+	if((index >= 0) && (index < sizeof(pref->audio_order))) {
+		slot = pref->audio_order[index];
 	}
 
 	return slot ? AST_FORMAT_LIST[slot-1].bits : 0;
 }
 
+int ast_codec_pref_index_video(const struct ast_codec_pref *pref, int index) 
+{
+	int slot = 0;
+
+	
+	if((index >= 0) && (index < sizeof(pref->video_order))) {
+		slot = pref->video_order[index];
+	}
+
+	return slot ? AST_FORMAT_LIST[slot-1].bits : 0;
+}
+
+int ast_codec_pref_bits(const struct ast_codec_pref *pref) {
+	return pref->audio_bits | pref->video_bits;
+}
+
 /*! \brief Remove codec from pref list */
 void ast_codec_pref_remove(struct ast_codec_pref *pref, int format)
 {
@@ -972,26 +1033,46 @@
 	int x, y = 0;
 	int slot;
 
-	if(!pref->order[0])
+	if(!(pref->audio_order[0] + pref->video_order[0]) ||
+	   !(ast_codec_pref_bits(pref) & format))
+	{
 		return;
-
+	}
 	memcpy(&oldorder, pref, sizeof(oldorder));
 	memset(pref, 0, sizeof(*pref));
 
 	for (x = 0; x < sizeof(AST_FORMAT_LIST) / sizeof(AST_FORMAT_LIST[0]); x++) {
-		slot = oldorder.order[x];
+		slot = oldorder.audio_order[x];
 		if(! slot)
 			break;
-		if(AST_FORMAT_LIST[slot-1].bits != format)
-			pref->order[y++] = slot;
+		if(AST_FORMAT_LIST[slot-1].bits != format) {
+			pref->audio_order[y++] = slot;
+			pref->audio_bits |= AST_FORMAT_LIST[slot - 1].bits;
+		}
+	}
+	for (y = 0, x = 0; x < sizeof(AST_FORMAT_LIST) / sizeof(AST_FORMAT_LIST[0]); x++) {
+		slot = oldorder.video_order[x];
+		if(! slot)
+			break;
+		if(AST_FORMAT_LIST[slot-1].bits != format) {
+			pref->video_order[y++] = slot;
+			pref->video_bits |= AST_FORMAT_LIST[slot - 1].bits;
+		}
 	}
-	
 }
 
 /*! \brief Append codec to list */
 int ast_codec_pref_append(struct ast_codec_pref *pref, int format)
 {
-	int x, newindex = -1;
+	int x, newindex = 0;
+	char *order = format < AST_FORMAT_MAX_AUDIO ?
+				pref->audio_order :
+				pref->video_order;
+	int *bits = format < AST_FORMAT_MAX_AUDIO ?
+				&pref->audio_bits :
+				&pref->video_bits;
+	if (!format)
+		return 0;
 
 	ast_codec_pref_remove(pref, format);
 
@@ -1004,8 +1085,9 @@
 
 	if(newindex) {
 		for (x = 0; x < sizeof(AST_FORMAT_LIST) / sizeof(AST_FORMAT_LIST[0]); x++) {
-			if(!pref->order[x]) {
-				pref->order[x] = newindex;
+			if(!order[x]) {
+				order[x] = newindex;
+				*bits |= format;
 				break;
 			}
 		}
@@ -1021,7 +1103,7 @@
 	int x, ret = 0, slot;
 
 	for (x = 0; x < sizeof(AST_FORMAT_LIST) / sizeof(AST_FORMAT_LIST[0]); x++) {
-		slot = pref->order[x];
+		slot = pref->audio_order[x];
 
 		if (!slot)
 			break;
@@ -1032,6 +1114,18 @@
 	}
 	if(ret & AST_FORMAT_AUDIO_MASK)
 		return ret;
+	for (x = 0; x < sizeof(AST_FORMAT_LIST) / sizeof(AST_FORMAT_LIST[0]); x++) {
+		slot = pref->video_order[x];
+
+		if(!slot)
+			break;
+		if ( formats & AST_FORMAT_LIST[slot-1].bits ) {
+			ret = AST_FORMAT_LIST[slot-1].bits;
+			break;
+		}
+	}
+	if(ret)
+		return ret;
 
 	if (option_debug > 3)
 		ast_log(LOG_DEBUG, "Could not find preferred codec - %s\n", find_best ? "Going for the best codec" : "Returning zero codec");
@@ -1072,6 +1166,108 @@
 				memset(pref, 0, sizeof(*pref));
 			}
 		}
+	}
+}
+
+void ast_codec_pref_append_missing2(struct ast_codec_pref *pref, int newformats)
+{
+	int i;
+	int format;
+
+	for (i = 0; i < 32; ++i) {
+		format = (1 << i);
+		if (!(format & ast_codec_pref_bits(pref)) &&
+		    (format & newformats))
+		{
+			ast_codec_pref_append(pref, format);
+		}
+	}
+}
+
+void ast_codec_pref_append_missing(struct ast_codec_pref *pref, const struct ast_codec_pref *newformats)
+{
+	int i;
+	int format;
+	const int size = sizeof(AST_FORMAT_LIST) / sizeof(struct ast_format_list);
+	int slot;
+
+	for (i = 0; i < size; i++) {
+		if (!(slot = newformats->audio_order[i]))
+			break;
+		format = AST_FORMAT_LIST[slot - 1].bits;
+		if (!(format & pref->audio_bits))
+			ast_codec_pref_append(pref, format);
+	}
+	for (i = 0; i < size; i++) {
+		if (!(slot = newformats->video_order[i]))
+			break;
+		format = AST_FORMAT_LIST[slot - 1].bits;
+		if (!(format & pref->video_bits))
+			ast_codec_pref_append(pref, format);
+	}
+}
+
+void ast_codec_pref_init(struct ast_codec_pref *pref)
+{
+	memset(pref, 0, sizeof(*pref));
+}
+
+void ast_codec_pref_set2(struct ast_codec_pref *pref, int formats)
+{
+	ast_codec_pref_init(pref);
+	ast_codec_pref_append_missing2(pref, formats);
+}
+
+int ast_codec_pref_intersect(const struct ast_codec_pref *pref1, const struct ast_codec_pref *pref2)
+{
+	return (pref1->video_bits | pref1->audio_bits) &
+		(pref2->video_bits | pref2->audio_bits);
+}
+
+int ast_codec_pref_eq_noorder(const struct ast_codec_pref *pref1, const struct ast_codec_pref *pref2)
+{
+	return (pref1->video_bits | pref1->audio_bits) ==
+		(pref2->video_bits | pref2->audio_bits);
+}
+
+void ast_codec_pref_combine(struct ast_codec_pref *dest, 
+			    const struct ast_codec_pref *main, 
+			    const int mask)
+{
+	const int size = sizeof(AST_FORMAT_LIST) / sizeof(struct ast_format_list);
+	int i;
+	int slot;
+	int format;
+
+	ast_codec_pref_init(dest);
+	for (i = 0; i < size; ++i)
+	{
+		if (!(slot = main->audio_order[i]))
+			break;
+		format = AST_FORMAT_LIST[slot - 1].bits;
+		if (mask & format)
+			ast_codec_pref_append(dest, format);
+	}
+	for (i = 0; i < size; ++i)
+	{
+		if (!(slot = main->video_order[i]))
+			break;
+		format = AST_FORMAT_LIST[slot - 1].bits;
+		if (mask & format)
+			ast_codec_pref_append(dest, format);
+	}
+}
+
+void ast_codec_pref_remove2(struct ast_codec_pref *pref, int formats)
+{
+	int i;
+	int format;
+
+	for (i = 0; i < 32; ++i)
+	{
+		format = (1 << i);
+		if (format & formats & ast_codec_pref_bits(pref))
+			ast_codec_pref_remove(pref, format);
 	}
 }
 
Index: funcs/func_channel.c
===================================================================
--- funcs/func_channel.c	(revision 34061)
+++ funcs/func_channel.c	(working copy)
@@ -67,11 +67,11 @@
 	if (!strcasecmp(data, "audionativeformat"))
 		/* use the _multiple version when chan->nativeformats holds multiple formats */
 		/* ast_getformatname_multiple(buf, len, chan->nativeformats & AST_FORMAT_AUDIO_MASK); */
-		ast_copy_string(buf, ast_getformatname(chan->nativeformats & AST_FORMAT_AUDIO_MASK), len);
+		ast_copy_string(buf, ast_getformatname(ast_codec_pref_index_audio(&chan->nativeformats, 0)), len);
 	else if (!strcasecmp(data, "videonativeformat"))
 		/* use the _multiple version when chan->nativeformats holds multiple formats */
 		/* ast_getformatname_multiple(buf, len, chan->nativeformats & AST_FORMAT_VIDEO_MASK); */
-		ast_copy_string(buf, ast_getformatname(chan->nativeformats & AST_FORMAT_VIDEO_MASK), len);
+		ast_copy_string(buf, ast_getformatname(ast_codec_pref_index_video(&chan->nativeformats, 0)), len);
 	else if (!strcasecmp(data, "audioreadformat"))
 		ast_copy_string(buf, ast_getformatname(chan->readformat), len);
 	else if (!strcasecmp(data, "audiowriteformat"))
Index: include/asterisk/channel.h
===================================================================
--- include/asterisk/channel.h	(revision 34061)
+++ include/asterisk/channel.h	(working copy)
@@ -116,6 +116,7 @@
 #include "asterisk/utils.h"
 #include "asterisk/linkedlists.h"
 #include "asterisk/stringfields.h"
+#include "asterisk/translate.h"
 
 
 #define AST_MAX_FDS		8
@@ -195,7 +196,7 @@
 	int properties;			/*!< Technology Properties */
 
 	/*! \brief Requester - to set up call data structures (pvt's) */
-	struct ast_channel *(* const requester)(const char *type, int format, void *data, int *cause);
+	struct ast_channel *(* const requester)(const char *type, const struct ast_codec_pref *format, void *data, int *cause);
 
 	int (* const devicestate)(void *data);	/*!< Devicestate call back */
 
@@ -260,6 +261,9 @@
 	/*! \brief Find bridged channel */
 	struct ast_channel *(* const bridged_channel)(struct ast_channel *chan, struct ast_channel *bridge);
 
+	/*! Try to fixup codecs */
+	void (*fixup_codecs)(struct ast_channel *chan, const struct ast_codec_pref *peer_codecs);
+
 	/*! \brief Provide additional read items for CHANNEL() dialplan function */
 	int (* func_channel_read)(struct ast_channel *chan, char *function, char *data, char *buf, size_t len);
 
@@ -372,12 +376,13 @@
 	unsigned short transfercapability;		/*!< ISDN Transfer Capbility - AST_FLAG_DIGITAL is not enough */
 	struct ast_frame *readq;
 	int alertpipe[2];
+	struct ast_trans_pvt *writetrans_matrix[MAX_FORMAT][MAX_FORMAT]; /*!< Write translation path */
+	struct ast_trans_pvt *readtrans_matrix[MAX_FORMAT][MAX_FORMAT];  /*!< Read translation path */
 
-	int nativeformats;				/*!< Kinds of data this channel can natively handle */
+	struct ast_codec_pref nativeformats;		/*!< Kinds of data this channel can natively handle */
 	int readformat;					/*!< Requested read format */
 	int writeformat;				/*!< Requested write format */
-	struct ast_trans_pvt *writetrans;		/*!< Write translation path */
-	struct ast_trans_pvt *readtrans;		/*!< Read translation path */
+	int lastreadformat;				/*!< Format of last frame read */
 	int rawreadformat;				/*!< Raw read format */
 	int rawwriteformat;				/*!< Raw write format */
 
@@ -597,7 +602,7 @@
  * by the low level module
  * \return Returns an ast_channel on success, NULL on failure.
  */
-struct ast_channel *ast_request(const char *type, int format, void *data, int *status);
+struct ast_channel *ast_request(const char *type, const struct ast_codec_pref *formats, void *data, int *status);
 
 /*!
  * \brief Request a channel of a given type, with data as optional information used 
@@ -612,9 +617,9 @@
  * \return Returns an ast_channel on success or no answer, NULL on failure.  Check the value of chan->_state
  * to know if the call was answered or not.
  */
-struct ast_channel *ast_request_and_dial(const char *type, int format, void *data, int timeout, int *reason, const char *cidnum, const char *cidname);
+struct ast_channel *ast_request_and_dial(const char *type, const struct ast_codec_pref *format, void *data, int timeout, int *reason, const char *cidnum, const char *cidname);
 
-struct ast_channel *__ast_request_and_dial(const char *type, int format, void *data, int timeout, int *reason, const char *cidnum, const char *cidname, struct outgoing_helper *oh);
+struct ast_channel *__ast_request_and_dial(const char *type, const struct ast_codec_pref *format, void *data, int timeout, int *reason, const char *cidnum, const char *cidname, struct outgoing_helper *oh);
 
 /*!\brief Register a channel technology (a new channel driver)
  * Called by a channel module to register the kind of channels it supports.
Index: include/asterisk/frame.h
===================================================================
--- include/asterisk/frame.h	(revision 34061)
+++ include/asterisk/frame.h	(working copy)
@@ -34,7 +34,10 @@
 #include "asterisk/endian.h"
 
 struct ast_codec_pref {
-	char order[32];
+	char audio_order[32];
+	char video_order[32];
+	int audio_bits;
+	int video_bits;
 };
 
 /*! \page Def_Frame AST Multimedia and signalling frames
@@ -228,6 +231,8 @@
 #define AST_FORMAT_SPEEX	(1 << 9)
 /*! iLBC Free Compression */
 #define AST_FORMAT_ILBC		(1 << 10)
+/*! ADPCM (G.726, 40kbps) */
+#define AST_FORMAT_G726_40	(1 << 11)
 /*! Maximum audio format */
 #define AST_FORMAT_MAX_AUDIO	(1 << 15)
 /*! Maximum audio mask */
@@ -469,14 +474,28 @@
 	can't be transcoded and we just have to pick whatever is supported
 */
 
+/*! \brief Return bitmap of common codecs of the two preferences */
+extern int ast_codec_pref_intersect(const struct ast_codec_pref *pref1, const struct ast_codec_pref *pref2);
 /*! \brief Initialize an audio codec preference to "no preference" See \ref AudioCodecPref */
 void ast_codec_pref_init(struct ast_codec_pref *pref);
 
+/*! \brief Returns true if both prefs consists of the same set of codecs disregarding their order */
+extern int ast_codec_pref_eq_noorder(const struct ast_codec_pref *pref1, const struct ast_codec_pref *pref2);
+
 /*! \brief Codec located at a particular place in the preference index See \ref AudioCodecPref */
-int ast_codec_pref_index(struct ast_codec_pref *pref, int index);
+extern int ast_codec_pref_index_audio(const struct ast_codec_pref *pref, int index);
+
+/*! \brief Video codec located at  a particular place in the preference index */
+extern int ast_codec_pref_index_video(const struct ast_codec_pref *pref, int index);
+
+/*! \brief Remove a codec from a preference list */
+extern void ast_codec_pref_remove(struct ast_codec_pref *pref, int format);
 
-/*! \brief Remove audio a codec from a preference list */
-void ast_codec_pref_remove(struct ast_codec_pref *pref, int format);
+/*! \brief Returns the full bitmap of all codecs */
+extern int ast_codec_pref_bits(const struct ast_codec_pref *pref);
+
+/*! \brief Append a codec to a preference list, removing it first if it was already there */
+extern int ast_codec_pref_append(struct ast_codec_pref *pref, int format);
 
 /*! \brief Append a audio codec to a preference list, removing it first if it was already there 
 */
@@ -493,11 +512,16 @@
  */
 void ast_parse_allow_disallow(struct ast_codec_pref *pref, int *mask, const char *list, int allowing);
 
-/*! \brief Dump audio codec preference list into a string */
-int ast_codec_pref_string(struct ast_codec_pref *pref, char *buf, size_t size);
+/*! \brief Dump codec preference list into a string */
+extern int ast_codec_pref_string(const struct ast_codec_pref *pref, char *buf, size_t size);
+
+/*! \brief Dump codec preference list into a string */
+extern char *ast_codec_pref_dump(char *buf, size_t size, const struct ast_codec_pref *pref);
 
-/*! \brief Shift an audio codec preference list up or down 65 bytes so that it becomes an ASCII string */
-void ast_codec_pref_convert(struct ast_codec_pref *pref, char *buf, size_t size, int right);
+/*! \brief Shift a codec preference list up 65 bytes so that it becomes an ASCII string */
+extern void ast_codec_pref_convert_to_buf(const struct ast_codec_pref *pref, char *buf, size_t size);
+/*! \brief Shift a codec preference list down 65 bytes so that it becomes an codec set */
+extern void ast_codec_pref_convert_from_buf(struct ast_codec_pref *pref, char *buf, size_t size);
 
 /*! \brief Returns the number of samples contained in the frame */
 int ast_codec_get_samples(struct ast_frame *f);
@@ -514,6 +538,57 @@
 { 
 	return (format == AST_FORMAT_ILBC) ? 30 : 20;
 }
+
+/*!
+ * \brief Append codecs.
+ * \param pref Codec set to be modified.
+ * \param newformats Bitmap of codecs to be appended.
+ *
+ * Append codecs from newformats to pref but only those that are not
+ * already in the pref.
+ */
+void ast_codec_pref_append_missing2(struct ast_codec_pref *pref, int newformats);
+
+/*!
+ * \brief Append codecs.
+ * \param pref Codec set to be modified.
+ * \param newformats Codecs to be appended.
+ *
+ * Append codecs from newformats to pref but only those that are not 
+ * already in the pref. Codecs appended after last codec in pref using 
+ * order from newformats.
+ */
+void ast_codec_pref_append_missing(struct ast_codec_pref *pref, const struct ast_codec_pref *newformats);
+
+/*!
+ * \brief Clear the pref then append formats given.
+ * \param pref Codec set to be set.
+ * \param formats Bitmap of codecs to be put to pref.
+ *
+ * Clears pref and puts given formats into it. Codec order is not well
+ * predictable so avoid using this function if codec order is important.
+ */
+void ast_codec_pref_set2(struct ast_codec_pref *pref, int formats);
+
+/*!
+ * \brief Combine codecs from main and mask and put them to dest.
+ * \param dest Codec set to be modified.
+ * \param main Source codec set.
+ * \param mask Bitmap of formats.
+ *
+ * Set dest to all codecs from main (in that order) but only 
+ * those that exist in mask. Previous content of dest is destroyed.
+ */
+void ast_codec_pref_combine(struct ast_codec_pref *dest, const struct ast_codec_pref *main, const int mask);
+
+/*!
+ * \brief Remove codecs.
+ * \param pref Codec set to be modified.
+ * \param formats Bitmap of codecs to be removed.
+ *
+ * Removes codecs that passed in bitmap formats from codec set pref.
+ */
+void ast_codec_pref_remove2(struct ast_codec_pref *pref, int formats);
 
 /*!
   \brief Adjusts the volume of the audio samples contained in a frame.
